<template>
  <section>
    <h3>Props</h3>
    <rui-empty v-if="!hasProps" content="This component has no props." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Required</th>
          <th>Type</th>
          <th>Default</th>
          <th>Allowed values</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(prop, key) in doc.props" :key="key">
          <td>
            <template v-if="prop.deprecated">
              <del><code>{{ prop.name }}</code></del>
              <p v-if="prop.deprecated === true" class="-text--small -text--warning">This prop is deprecated without additional details</p>
              <p v-else class="-text--small -text--warning">Deprecated: {{ prop.deprecated }}</p>
            </template>
            <template v-else><code>{{ prop.name }}</code></template>
          </td>
          <td>{{ prop.required ? 'Yes' : '' }}</td>
          <td>{{ prop.type?.name || '-' }}</td>
          <td><code v-if="prop.defaultValue">{{ prop.defaultValue.func ? 'function' : prop.defaultValue.value }}</code></td>
          <td>
            <div v-if="prop.values.length > 0" class="-inline-flex -flex--gap">
              <code v-for="value in prop.values" :key="value">{{ value }}</code>
            </div>
          </td>
          <td><markdown-renderer v-if="prop.description" :raw="prop.description" /></td>
        </tr>
      </tbody>
    </table>
  </section>

  <h3>Events</h3>
  <section>
    <rui-empty v-if="!hasEvents" content="This component has no events." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Description</th>
          <th>Parameters</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(event, key) in doc.events" :key="key">
          <td><code>{{ event.name }}</code></td>
          <td><markdown-renderer v-if="event.description" :raw="event.description" /></td>
          <td>
            <div v-for="property in event.properties" :key="property.name">
              <span class="-text--smaller">
                {<code v-for="type in property.type.names" :key="type">{{ type }}</code>}
              </span>
              <code>{{ property.name }}</code>
              {{ property.description ? `&mdash; ${property.description}` : '' }}
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </section>

  <h3>Slots</h3>
  <section>
    <rui-empty v-if="!hasSlots" content="This component has no slot." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(slot, key) in doc.slots" :key="key">
          <td><code>{{ slot.name }}</code></td>
          <td><markdown-renderer v-if="slot.description" :raw="slot.description" /></td>
        </tr>
      </tbody>
    </table>
  </section>
</template>

<script>
import documentation from '../documentation.json'
import MarkdownRenderer from './MarkdownRenderer.vue'

export default {
  name: 'ComponentApi',
  components: { MarkdownRenderer },
  props: {
    name: { required: true, type: String },
  },
  data () {
    const doc = documentation[this.name]

    return {
      doc,
      hasProps: doc.props.length > 0,
      hasEvents: doc.events.length > 0,
      hasSlots: doc.slots.length > 0,
    }
  },
}</script>
